#include "../includeCU/sfx_surface.cuh"

// template<typename T>
// __device__ void get_charnock_roughness(T &z0_m, T &u_dyn0,
//     const T h, const T U,
//     const T kappa, 
//     const T h_charnock, const T c1_charnock, const T c2_charnock, 
//     const int maxiters)
// {
//     T Uc, a, b, c, c_min, f;

//     Uc = U;
//     a = 0.0;
//     b = 25.0;
//     c_min = log(h_charnock) / kappa;

//     for (int i = 0; i < maxiters; i++)
//     {
//         f = c1_charnock - 2.0 * log(Uc);
//         for (int j = 0; j < maxiters; j++)
//         {
//             c = (f + 2.0 * log(b)) / kappa;
//             if (U <= 8.0e0) 
//                 a = log(1.0 + c2_charnock * ( pow(b / Uc, 3) ) ) / kappa;
//             c = max(c - a, c_min);
//             b = c;
//         }
//         z0_m = h_charnock * exp(-c * kappa);
//         z0_m = max(z0_m, T(0.000015e0));
//         Uc = U * log(h_charnock / z0_m) / log(h / z0_m);
//     }
    
//     u_dyn0 = Uc / c;
// }

// template __device__ void get_charnock_roughness(float &z0_m, float &u_dyn0,
//     const float h, const float U,
//     const float kappa, 
//     const float h_charnock, const float c1_charnock, const float c2_charnock, 
//     const int maxiters);
// template __device__ void get_charnock_roughness(double &z0_m, double &u_dyn0, 
//     const double h, const double U,
//     const double kappa, 
//     const double h_charnock, const double c1_charnock, const double c2_charnock,
//     const int maxiters);
    